'Egy BASIC mintaprogram a PICPLC1 panelre.
'A CS2 csatlakozn egy 8-as DIP kapcsol , az LCD a kijelzshez
'Digitlis bemenetek beolvassa, kijelzse, s egy kis jtk a bitekkel
'A program beolvassa a 8 kapcsolt, kirja bitenknt, aztn hexa, s decimlis szmknt.
's - mint egy szmkdos bicikli lakat - behzza a relt, ha a 00011100 a kd

'Elszr is kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	0	' Az els adatvezetk az RD port 0. tagja. (Az RD0)
	DEFINE LCD_RSREG 	PORTD ' Az LCD Register Select kivezetse a D portra csatlakozik,
	DEFINE LCD_RSBIT 	4	' mgpedig az RD4 labra. (Tehat az LCD RS - az RD4 porton van.)
	DEFINE LCD_EREG 	PORTD ' Az enable vezerl bit is a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva. (LCD EN - RD5 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

	TRISA = %00001111	' A PORTA0-3 input, a PORTA 4-7 output
	TRISB = %00111111	' A PORTB0-5 input, 6-7 output
	TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output

	RELE VAR PORTA.5   ' A rel a PORTA 5-n van
	    
	' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
	' analg portnak hasznlni. 
	' Ezeket az ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
	' Szval most a PORTA0-7 mind mint digitlis port legyen hasznlva.
	
	ADCON1 = %00000111	' Az ADCON1 regiszter 

	' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban

	DIP8 var byte	' Ebbe olvassuk majd bele a DIP8 kapcsol llapott
	PUFFER var byte	' Egy tmeneti tr	
    
   	LCDFRISS var BIT ' Egy jelz bit. Azt jelzi, hogy frissteni kell az LCD-n a kirst
    LCDFRISS = 1     ' Bekapcsols utn mindjrt rjunk is az LCD-re
    
main:       
 
    Puffer = DIP8   'Elmentjk a DIP kapcsol utols llapott, aztn beolvassuk bitenknt
    DIP8.0 = PORTB.0 : DIP8.1 = PORTB.1 : DIP8.2 = PORTB.2 : DIP8.3 = PORTB.3
    DIP8.4 = PORTB.4 : DIP8.5 = PORTB.5 : DIP8.6 = PORTE.0 : DIP8.7 = PORTE.1     
    
    If PUFFER != DIP8 THEN  'Ha nem azonos az elz llapottal, akkor
        TOGGLE PORTA.4      'vltjuk az L2 led llapott 
        LCDFRISS = 1        's frissteni kell az LCD-t is, bebillentjk a jelzbitet               
        'RELE = 1, ha a DIP8 00011100  A ! jel a negls, az & az S kapcsolatot jelenti
        RELE = !DIP8.7 & !DIP8.6  & !DIP8.5 & DIP8.4 & DIP8.3 & DIP8.2 & !DIP8.1 & !DIP8.0 
    endif
         
    If LCDFRISS = 1 THEN
       LCDOUT $fe,$80,"DIP8: ",#DIP8.7,#DIP8.6,#DIP8.5,#DIP8.4,#DIP8.3,#DIP8.2,#DIP8.1,#DIP8.0 ' irs az els sorba
       LCDOUT $fe,$C0,"H:",hex2 DIP8," D:",dec3 DIP8," REL:",#RELE  'Kt szmjegyen hexa, hrom szmjegyen decimlis
       LCDFRISS = 0  'Kirtuk amit kell, a jelz bitet most mr alaphelyzetbe lltjuk                        
    endif 
	      
    goto main		' Ugras a ciklus elejere, kezdodik minden ujra... 

    END				' Itt a progi vege. 
